﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	#If B4J
	Private fx As JFX
	#End If
	Private clrfunctions As colorfunctions
	Private clvnamedcolors As CustomListView
	Private ftfcolorname As B4XFloatTextField
	Private ftfhex1 As B4XFloatTextField
	Private ftfhex2 As B4XFloatTextField
	Private lblalpha As Label
	Private lblblue As Label
	Private lblC As Label
	Private lblgreen As Label
	Private lblhue As Label
	Private lblK As Label
	Private lblM As Label
	Private lblnameindex As Label
	Private lblred As Label
	Private lblsat As Label
	Private lblval As Label
	Private lblY As Label
	Private jlst As List
	Private RGB As List
	Private lblcolor As Label
	Private lblcolorname As Label
	Private printcolors() As Int
	Private bsalpha As B4XSeekBar
	Private bsblue As B4XSeekBar
	Private bsgreen As B4XSeekBar
	Private bsred As B4XSeekBar
	Private ARGB As List
	Private btnshow1 As Button
	Private btnshow2 As Button
	Private lblint As Label
	#If B4A
	Private pnlcolors As Panel
	#End if
	#If B4J
	Private pnlcolors As Pane
	#End If
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	#If B4A
	Root.LoadLayout("b4apage_layout")
	#End if
	#If B4J
	Root.LoadLayout("b4jpage_layout")
	#End if
	clrfunctions.Initialize
	fill_clvnamedcolors
End Sub
#Region B4X code
Public Sub fill_clvnamedcolors
	Dim jstr As String = File.ReadString(File.DirAssets,"colornames.json")
	jlst = jstr.As(JSON).ToList
	clvnamedcolors.Clear
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		#If B4A
		Dim pn As Panel = set_clvnamedcolor_item(rec,i)
		#End if
		#If B4J
		Dim pn As Pane = set_clvnamedcolor_item(rec,i)
		#End If
		clvnamedcolors.Add(pn,rec.Get(2))
	Next
End Sub
#If B4A
Private Sub set_clvnamedcolor_item(rec As List,index As Int) As Panel
#End if
#If B4J
Private Sub set_clvnamedcolor_item(rec As List,index As Int) As Pane
#End If
	#If B4A
	Dim pn As Panel
	#End if
	#If B4J
	Dim pn As Pane
	#End If
	pn.Initialize("")
	pn.LoadLayout("clvnamedcolorsitem_layout")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 280dip, 45dip)
	Dim clrstr As String = rec.Get(3)			' red, green, blue
	RGB = clrfunctions.set_RGB_values(clrstr)
	lblcolor.Text = " " & index
	#If B4A
	lblcolor.TextColor = clrfunctions.ContrastColor(xui.Color_ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
	lblcolor.Color = xui.Color_ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2))
	#End if
	#If B4J
	lblcolor.TextColor = fx.Colors.From32Bit(clrfunctions.ContrastColor(xui.Color_ARGB(255,RGB.get(0),RGB.get(1),RGB.get(2))))
	lblcolor.Style = "-fx-background-color:" & rec.Get(2)
	#End if
	lblcolorname.Text = " " & rec.Get(1)
	Return pn
End Sub
Private Sub clvnamedcolors_ItemClick (Index As Int, Value As Object)
	Dim rec As List = jlst.Get(Index+1)
	Dim clrstr As String = rec.Get(3)
	RGB = clrfunctions.set_RGB_values(clrstr)
	lblalpha.Text = "255"
	lblred.Text = RGB.get(0)
	lblgreen.Text = RGB.get(1)
	lblblue.Text = RGB.get(2)
	lblnameindex.Text = rec.Get(0)
	ftfcolorname.Text = rec.Get(1)
	bsalpha.Value = lblalpha.Text
	bsred.Value = lblred.Text
	bsgreen.Value = lblgreen.Text
	bsblue.Value = lblblue.Text
	show_color_info
End Sub
Private Sub show_color_info
	change_background
	fill_hsv_colors(xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text))
	fill_print_colors
	set_hex_values
	lblint.Text = xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text)
	check_named_colors_list
End Sub
private Sub fill_print_colors
	printcolors = clrfunctions.RGB2CMYK(lblred.text, lblgreen.Text, lblblue.Text)
	lblC.Text = printcolors(0) & " %"
	lblM.Text = printcolors(1) & " %"
	lblY.Text = printcolors(2) & " %"
	lblK.Text = printcolors(3) & " %"
End Sub
Private Sub fill_hsv_colors(clr As Int)
	Dim hsva(4) As Object = clrfunctions.ColorToHSV(clr)
	lblhue.Text = Round(hsva(0)) & " °"
	lblsat.Text = Round(hsva(1)*100) & " %"
	lblval.Text = Round(hsva(2)*100) & " %"
End Sub
Private Sub set_hex_values
	Dim clr1 As String = clrfunctions.ColorToHex(xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text))
	ftfhex1.Text = "0x" & clr1
	Dim clr2 As String = clrfunctions.ColorToHex(xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text))
	ftfhex2.Text = "#FF" & clr2.SubString(2)
End Sub
Private Sub check_named_colors_list
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		If lblalpha.Text = "255" Then
			Dim clrstr As String = rec.Get(3)
			If clrstr = lblred.Text & "," & lblgreen.Text & "," & lblblue.Text Then
				lblnameindex.Text = rec.Get(0)
				ftfcolorname.Text = rec.Get(1)
				clvnamedcolors.JumpToItem(rec.Get(0)-1)
			End If
		End If
	Next
End Sub
Private Sub bsred_ValueChanged (Value As Int)
	lblred.Text = Round(Value)
	lblnameindex.Text = ""
	ftfcolorname.Text = ""
	show_color_info
End Sub
Private Sub bsgreen_ValueChanged (Value As Int)
	lblgreen.Text = Round(Value)
	lblnameindex.Text = ""
	ftfcolorname.Text = ""
	show_color_info
End Sub
Private Sub bsblue_ValueChanged (Value As Int)
	lblblue.Text = Round(Value)
	lblnameindex.Text = ""
	ftfcolorname.Text = ""
	show_color_info
End Sub
Private Sub bsalpha_ValueChanged (Value As Int)
	lblalpha.Text = Round(Value)
	lblnameindex.Text = ""
	ftfcolorname.Text = ""
	show_color_info
End Sub
Private Sub btnshow1_Click
	Dim hexstring As String = ftfhex1.Text
	If hexstring.Length = 10 Then
		If hexstring.StartsWith("0x") Then
			Dim hcolor As Int = clrfunctions.HexToColor(hexstring)
			ARGB = clrfunctions.GetARGB(hcolor)
			Log(ARGB)
			lblalpha.Text = ARGB.get(0)
			lblred.Text = ARGB.get(1)
			lblgreen.Text = ARGB.get(2)
			lblblue.Text = ARGB.get(3)
			lblnameindex.Text = ""
			ftfcolorname.Text = ""
			show_color_info
		End If
	End If
	
End Sub
Private Sub btnshow2_Click
	Dim hexstring As String = ftfhex2.Text
	If hexstring.Length = 9 Then
		If hexstring.StartsWith("#") Then
			Dim hcolor As Int = clrfunctions.HexToColor(hexstring)
			ARGB = clrfunctions.GetARGB(hcolor)
			Log(ARGB)
			lblalpha.Text = "255"
			lblred.Text = ARGB.get(1)
			lblgreen.Text = ARGB.get(2)
			lblblue.Text = ARGB.get(3)
			lblnameindex.Text = ""
			ftfcolorname.Text = ""
			show_color_info
		End If
	End If
End Sub

#End Region

#Region B4A code
#If B4A
Private Sub change_background
	pnlcolors.Color = xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text)
	Root.Color = xui.Color_ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text)
End Sub
#End if
#End Region

#Region B4J code
#If B4J
Private Sub change_background
	CSSUtils.SetBackgroundColor(pnlcolors,fx.Colors.ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text))
	CSSUtils.SetBackgroundColor(Root,fx.Colors.ARGB(lblalpha.Text,lblred.Text,lblgreen.Text,lblblue.Text))
End Sub
#End if
#End Region

