﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
End Sub
Public Sub Initialize
	'
End Sub
Public Sub ContrastColor(Color As Int) As Int
	Dim lum As Double = 1 - (0.299 * Bit.And(Bit.ShiftRight(Color,16),0xFF) + 0.587 * Bit.And(Bit.ShiftRight(Color,8),0XFF) + 0.114 * Bit.And(Color,0xFF)) / 255
	If lum < 0.5 Then
		Return xui.Color_Black
	Else
		Return xui.Color_White
	End If
End Sub
Public Sub ColorToHex(clr As Int) As String
	Dim bc As ByteConverter
	Return bc.HexFromBytes(bc.IntsToBytes(Array As Int(clr)))
End Sub
Public Sub HexToColor(Hex As String) As Int
	Dim bc As ByteConverter
	If Hex.StartsWith("#") Then
		Hex = Hex.SubString(1)
	Else If Hex.StartsWith("0x") Then
		Hex = Hex.SubString(2)
		Log("hex: " & Hex)
	End If
	Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(Hex))
	Return ints(0)
End Sub
Public Sub set_RGB_values(clrstr As String) As List
	' clrstr = red,green,blue
	Dim lst As List
	lst.Initialize
	lst.Add(clrstr.SubString2(0,clrstr.IndexOf(",")))
	lst.Add(clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(",")))
	lst.Add(clrstr.SubString(clrstr.LastIndexOf(",")+1))
	Return lst
End Sub
Public Sub RGB2CMYK(R As Int, G As Int, B As Int) As Int()
	Dim PercentageR As Double = R / 255 * 100
	Dim PercentageG As Double = G / 255 * 100
	Dim PercentageB As Double = B / 255 * 100
	Dim K As Double = 100 - Max(Max(PercentageR,PercentageG),PercentageB)
	If k = 100 Then Return Array As Int(0,0,0,100)
	Dim C As Int = ((100 - PercentageR - K) / (100 - K) * 100)
	Dim M As Int = ((100 - PercentageG - K) / (100 - K) * 100)
	Dim Y As Int = ((100 - PercentageB - K) / (100 - K) * 100)
	Return Array As Int(C,M,Y,K)
End Sub
Public Sub ColorToHSV(clr As Int) As Object()
	Dim a As Int = Bit.And(0xff, Bit.UnsignedShiftRight(clr, 24))
	Dim r As Int = Bit.And(0xff, Bit.UnsignedShiftRight(clr, 16))
	Dim g As Int = Bit.And(0xff, Bit.UnsignedShiftRight(clr, 8))
	Dim b As Int = Bit.And(0xff, Bit.UnsignedShiftRight(clr, 0))
	Dim h, s, v As Float
	Dim cmax As Int = Max(Max(r, g), b)
	Dim cmin As Int = Min(Min(r, g), b)
	v = cmax / 255
	If cmax <> 0 Then
		s = (cmax - cmin) / cmax
	End If
	If s = 0 Then
		h = 0
	Else
		Dim rc As Float = (cmax - r) / (cmax - cmin)
		Dim gc As Float = (cmax - g) / (cmax - cmin)
		Dim bc As Float = (cmax - b) / (cmax - cmin)
		If r = cmax Then
			h = bc - gc
		Else If g = cmax Then
			h = 2 + rc - bc
		Else
			h = 4 + gc - rc
		End If
		h = h / 6
		If h < 0 Then h = h + 1
	End If
	Return Array (h * 360,s,v,a)
End Sub
Public Sub GetARGB(color As Int) As List
	Private alpha As Int = Bit.UnsignedShiftRight(Bit.And(color, 0xff0000), 24)
	Private red As Int = Bit.UnsignedShiftRight(Bit.And(color, 0xff0000), 16)
	Private green As Int = Bit.UnsignedShiftRight(Bit.And(color, 0xff00), 8)
	Private blue As Int = Bit.And(color, 0xff)
	Dim lst As List
	lst.Initialize
	lst.Add(alpha)
	lst.Add(red)
	lst.Add(green)
	lst.Add(blue)
	Return lst
End Sub